/****************************************************************
**
** Definition of GameBoard class, Qt tutorial 14
**
****************************************************************/

#ifndef GAMEBRD_H
#define GAMEBRD_H

#include <qwidget.h>
#include <qdom.h>
#include "sector.h"

class QPushButton;
class LCDRange;
class QLCDNumber;
class CannonField;
class QLabel;
class QTimer;


class GameBoard : public QWidget
{
    Q_OBJECT

public:
    GameBoard( QWidget *parent=0, const char *name=0 );

protected slots:
    void  readFile1();
    void  readFile2();
    void  setText1();
    void  setText2();
    void startTimer();
    void showEvent0();
    void showEvent1();
    void stop();

private:
		QLabel *fileLabel1;
		QLabel *fileLabel2;
    QTimer *timer0;
    QTimer *timer1;
		QDomDocument   domTree;
    Sector* s0;
    Sector* s1;
    int i0;
    int i1;
};

#endif // GAMEBRD_H
