#include "sector.h"
#include <qtimer.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qdatetime.h>
#include <qdom.h>
#include <qstring.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
using namespace std;

Sector::Sector(QWidget *parent, const char* name)
	: QWidget(parent, name)
{
  eventList.resize(3000);
	setPalette(QPalette(QColor( 250, 250, 200)));
}

void Sector::getTrace(const QDomElement& root){
  QDomNode node;
  node = root.firstChild();
  while ( !node.isNull() ) {
    if ( node.isElement() && node.nodeName() == "events" ) {
      QDomElement events = node.toElement();
      //cout << "get events ...." << endl;
      getEvents( events );
      break;
    }
    node = node.nextSibling();
  }	
}

void Sector::getEvents(const QDomElement& events){
    QDomNode node = events.firstChild();
    //cout << "node name " << node.nodeName() << endl;
    while ( !node.isNull() ) {
        if ( node.isElement() ) {
            // case for the different header entries
            //cout << "node name " << node.nodeName() << endl;
            if ( node.nodeName() == "event" ) {
							QDomNode tNode = node.firstChild();
							BallEvent* bp = new BallEvent();
							bp->ballList.resize(50);
              while(!tNode.isNull()){
								if(tNode.nodeName() == "time"){
                  //cout << "time node ..........." << endl;
                  QDomText textChild = tNode.firstChild().toText();
									bp->timeStamp = QString(textChild.nodeValue()).toDouble();
								}
								if(tNode.nodeName() == "ballstates"){
                  //cout << "ball state ..........." << endl;
 							    QDomNode bNode = tNode.firstChild();
									while(!bNode.isNull()){
									  if(bNode.nodeName() =="ball"){
										  if(bNode.hasAttributes()){
	                      //cout << "ball has attributes ........ " << endl;
												BallState * bs = new BallState();
										  	QDomNamedNodeMap attrMap = bNode.attributes();
										  	QDomNode idNode = attrMap.namedItem("id");
                        //cout << "id = " << idNode.firstChild().toText().nodeValue()<<endl;
												bs->id = QString(idNode.firstChild().toText().nodeValue()).toInt();

										  	QDomNode vNode = attrMap.namedItem("v");
                        //cout << "id = " << idNode.firstChild().toText().nodeValue()<<endl;
												bs->v = QString(vNode.firstChild().toText().nodeValue()).toDouble();

										  	QDomNode aNode = attrMap.namedItem("angle");
                        //cout << "id = " << idNode.firstChild().toText().nodeValue()<<endl;
												bs->angle = QString(aNode.firstChild().toText().nodeValue()).toDouble();

										  	QDomNode xNode = attrMap.namedItem("x");
                        //cout << "id = " << idNode.firstChild().toText().nodeValue()<<endl;
												bs->x = QString(xNode.firstChild().toText().nodeValue()).toDouble();

										  	QDomNode yNode = attrMap.namedItem("y");
                        //cout << "id = " << idNode.firstChild().toText().nodeValue()<<endl;
												bs->y = QString(yNode.firstChild().toText().nodeValue()).toDouble();

												bp->ballList.insert(bp->ballList.count(), bs);
                      //QDomNode attrChild = bNode.firstChild(); //.toAttr();
											//cout << "child type " << attrChild.nodeType() << endl;
											//cout << "child name " << attrChild.nodeName() << endl;
										  }
									  }
									  bNode = bNode.nextSibling();
                  }
								}
								tNode = tNode.nextSibling();
							}
  					  eventList.insert(eventList.count(), bp);
            }
        }
        node = node.nextSibling();
    }
/*    int len = eventList.count();
		for(int i = 0; i < len; i ++){
			cout << "Time stamp " << eventList[i]->timeStamp << endl;
			int num = eventList[i]->ballList.count();
			for(int j = 0; j < num; j++){
				cout << "\tBall id = " << eventList[i]->ballList[j]->id;
				cout << " v = " << eventList[i]->ballList[j]->v;
				cout << " angle = " << eventList[i]->ballList[j]->angle;
				cout << " x = " << eventList[i]->ballList[j]->x;
				cout << " y = " << eventList[i]->ballList[j]->y;
				cout << endl;
			}
		}	
*/
}

//void showEvent(int eNum);
void Sector::showEvent(int i, int xOff){
  repaint();
	QPainter p(this);
  p.setBrush(black);
	p.setPen(NoPen);

	BallEvent *bp = eventList[i];
	int num = bp->ballList.count();
  cout << "event " << i << " at time " << bp->timeStamp << endl;
  //int j = 0;
	for(int j = 0; j < num; j++){
    p.drawPie(QRect((int)floor((bp->ballList[j]->x-xOff)*15), (int)floor(bp->ballList[j]->y)*15, 15, 15)
						 , 0
             , 360*16
             );
	  p.setPen(green);
	  p.setFont(QFont("Courier", 8, QFont::Bold));
	  p.drawText(QRect((int)floor((bp->ballList[j]->x-xOff)*15), (int)floor(bp->ballList[j]->y)*15, 15, 15)
							, AlignCenter
							, QString::number(bp->ballList[j]->id, 10)
							);
	  p.setPen(red);
    int x = QRect((int)floor((bp->ballList[j]->x-xOff)*15), (int)floor(bp->ballList[j]->y)*15, 15, 15).center().x();
    int y = QRect((int)floor((bp->ballList[j]->x-xOff)*15), (int)floor(bp->ballList[j]->y)*15, 15, 15).center().y();
	  p.drawLine( x
              , y
              , x+(int)(15*cos(bp->ballList[j]->angle*3.14159265/180))
              , y-(int)(15*sin(bp->ballList[j]->angle*3.14159265/180))
              );
	}
}
//void Sector::paintEvent(QPaintEvent *e)
//{
//}
