#ifndef CANNON_H
#define CANNON_H

class QTimer;
class QDomElement;

#include <vector>
#include <qwidget.h>
#include <qptrvector.h>
class BallState{

public:
	int    id;
	double v;
	double angle;
  double x;
  double y;

	BallState(){}
};

class BallEvent{

public:
	double timeStamp;
  char   type[80];
  QPtrVector<BallState> ballList;

  BallEvent(){}
  BallEvent(const BallEvent& src){
    timeStamp=src.timeStamp;
  }	
};

class Sector: public QWidget
{
	Q_OBJECT

	public:
		Sector(QWidget *parent=0, const char* name=0);
		void getEvents(const QDomElement& node);

	public slots:
		void getTrace(const QDomElement& root);
		void showEvent(int eNum, int xOff);

//	protected:
//		void paintEvent(QPaintEvent *);

	public:
		QPtrVector<BallEvent> eventList;
};
#endif // CANNON_H
