#include "datastructure.h"

/////////////////////////////////////////////
//	Event
/////////////////////////////////////////////
class Event{
  public:
    enum EventType{ Empty, Collision, Arrival, Departure, Bounce};
    double     timeStamp;
    EventType  type;
    Billiard*  ball;
    Billiard*  ball1; //special for collision event
    
    Event(){
			timeStamp=100000.0;
			type  = EventType::Empty;
			ball  = NULL;
      ball1 = NULL;
		}

    Event(double t, EventType eType, const Billiard* b, const Balliard* b1=NULL){
      timeStamp = t;
      type      = eType;
      ball      = b;
      ball1     = b1;
    }

    Event(const Event& src){
			timeStamp = src.timeStamp;
      type      = src.type;
      ball      = src.ball;
      ball1     = src.ball1;
    }

		Event& operator=(const Event& src){
			timeStamp = src.timeStamp;
      type      = src.type;
      ball      = src.ball;
      ball1     = src.ball1;
      return *this;			
		}

    bool operator<(const Event& src){
			return (timeStamp < src.timeStamp);
    }
    bool operator==(const Event& src){
			return (timeStamp == src.timeStamp);
    }

    void print(){
      cout << "Event : \n\t--time " << timeStamp << " type " << type;
      if(ball!=NULL){
        cout << "\n\t--ball ";
				ball->print();
      }
      if(ball1!=NULL){
        cout << "\n\t--ball1 ";
				ball1->print();
      }
    }
};


//class CollisionEvent: public Event{
//  public:
//    Billiard ball1;
//    CollisionEvent(){}
//    CollisionEvent(double t, EventType eType, Billiard b, Billiard b1)
//								  :Event(t, eType, b), ball1(b1){}
//
//};
